/************************************(abc898-18325.c)****
 *  RTC (DS1307)@eXg
 ********************************************************/

#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/examples/i2c1_master_example.h"
#include <string.h>
#include "i2cLCD_ST7032i.h"

#define DS1307 0x68

//**** O[oϐ

uint8_t RBuf[BFSIZE];
uint8_t SFlg;

char    SBuf[20];

uint8_t DayTm[]={ 0,	// seconds
				  30,	// minutes
				  10,	// Hours(24h)
				  6,	// day[week]
				  12,	// date
				  7,	// month
				  24,	// year
				  0 };	// SQW/OUT

//**** ėp֐ ************************
//---- BCD2iɕϊ
uint8_t bcd2bin(uint8_t bcd){
	return  ((bcd >> 4)& 0x0F) * 10 + (bcd & 0x0F);
}
//---- 2iBCDɕϊ
uint8_t bin2bcd(uint8_t bin){
	return  (uint8_t)((uint16_t)(bin / 10) << 4) + (bin % 10);
}

/*=====================================================
 *	񂩂琔loA1oCgzɋtŊi[
 *		buf:	oli[1oCgz
 *		src:	lo
 *		delim:	؂蕶𕶎ɂ
 *	i߂lj: 擾ol̐
 *====================================================*/
uint8_t get_BytesNumRev(uint8_t *buf, char *src,char *delim){
    uint8_t *ptr;
    uint8_t bt, n = 0;
    ptr = strtok(src,delim);
    while(ptr != NULL){
        bt = (uint8_t)atoi(ptr);
        *buf-- = bt;
        n++;
        ptr = strtok(NULL,delim);
    }
    return n;
}

/*******************************************
 * 	RTCp֐
 ******************************************/
//--- RTCadrԒndatf[^
void RTC_write(uint8_t adr, uint8_t dat){
    uint8_t bf[3];
    bf[0]=adr;						// Address = adr
    bf[1]=dat;
    I2C1_WriteNBytes(DS1307,bf,2);
}
//--- RTCadrԒndatf[^ǂݍ
uint8_t RTC_read(uint8_t adr){
    uint8_t bf[3];
    bf[0]= adr;						// Address = adr
	I2C1_WriteNBytes(DS1307,bf, 1);	// Set Address
	I2C1_ReadNBytes(DS1307, bf, 1);	// Read Data
    return bf[0];
}
//--- RTC̑SĂrtcf[^ǂݍ
void RTC_readAll(uint8_t *buf){
	uint8_t rtc[8],i;
	rtc[0]=0;						// Address = 0
	I2C1_WriteNBytes(DS1307,rtc,1);	// Set Address
	I2C1_ReadNBytes(DS1307, rtc,8);	// Read Data
	for(i=0;i<8;i++){
		buf[i]=bcd2bin(rtc[i]);
	}
}
//--- RTC̑SĂrtcɃf[^
void RTC_writeAll(uint8_t *buf){
	uint8_t rtc[9],i;
	rtc[0]=0;						// Address = 0
	for(i=0;i<8;i++){
		rtc[i+1]=bin2bcd(buf[i]);
	}
	I2C1_WriteNBytes(DS1307,rtc,9);
}
//--- RTC̎wAhXnoCg̃f[^
//		buf:	ރf[^i[ꂽz
//		adr:	RTCAhX
//		n:		ރoCg
void RTC_writePrt(uint8_t *buf,uint8_t adr, uint8_t n){
	uint8_t rtc[9],i;
	rtc[0]=adr;						// Address = adr
	for(i = 0;i < n;i++){
		rtc[i+1]=bin2bcd(buf[adr+i]);
	}
	I2C1_WriteNBytes(DS1307,rtc,n+1);
}

//***** R}h *****
//---- q(read)R}h
void cmd_r(){
    uint8_t i;
	RTC_readAll(DayTm);
	for(i = 0; i < 8; i++){
		printf("%d: %02d\n\r",i,DayTm[i]);
	}
}
//---- c(date)R}h		"Dyy/mm/dd/w"
void cmd_d(){
	uint8_t n,i;
	n = get_BytesNumRev(DayTm+6,RBuf+1,"/");
	if((n > 0)&&(n < 5)){
/*        for(i = 3;i < 7;i++){
            printf("%d:%d\n\r",i,DayTm[i]);
        }*/
		RTC_writePrt(DayTm,3,4);
	}
}
//---- s(time)R}h		"Thh:mm"Ab0
void cmd_t(){
	uint8_t n,i;
	n = get_BytesNumRev(DayTm+2,RBuf+1,":");
    printf("%d\n\r",n);
	if((n > 0) && (n < 4)){
/*        for(i = 0;i < 3;i++){
            printf("%d:%d\n\r",i,DayTm[i]);
        }*/
		RTC_writePrt(DayTm,0,3);
	}
}

/*
                         Main application
 */
void main(void)
{
 	uint8_t cmd;
    uint8_t sec;
    
    SYSTEM_Initialize();
    LCD_init();

    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();

    puts("ready\n\r");
	RTC_writeAll(DayTm);

    sec = 0;
    while (1)
    {
		if(SFlg){
			cmd = RBuf[0]; printf("\n\r");
			switch(cmd){
				case 'R': cmd_r();	break;
				case 'T': cmd_t();	break;
				case 'D': cmd_d();	break;
				default:			break;
			}
			SFlg = 0;
		}
        RTC_readAll(DayTm);
        if(sec != DayTm[0]){
            sprintf(SBuf,"20%02d/%02d/%02d(%d)",DayTm[6],DayTm[5],DayTm[4],DayTm[3]);
            LCD_clr();  LCD_str(SBuf); 
          //  printf("%s ",SBuf);
            sprintf(SBuf,"%02d:%02d:%02d",DayTm[2],DayTm[1],DayTm[0]);
            LCD_cursor(0,1); LCD_str(SBuf);
          // printf("%s\n\r",SBuf);
            sec = DayTm[0];
        }
    }
}
/****  End of File  ***/